package com.ca.smdeletesession;

import com.sf.smutils.util.DataEncryptor;
import com.sf.smutils.util.RuntimeProperties;

public class EncryptPassword {

    /**
     * @param args
     */
    public static void main(String[] argv) {
        EncryptPassword main = new EncryptPassword();
        main.runMain(argv);
    }
    
    
    public void runMain(String[] argv) {

        try { 

            if (argv.length != 2) {
                System.out.println("Usage is 'EncryptPassword [Check|Generate] <Password>'");
                return;
            }

            String cmd = argv[0];
            String pwd = argv[1];
            
            cmd = cmd.toLowerCase();
            
            if (cmd.equals("check")) {
                doCheck(pwd);
            }
            else if (cmd.equals("generate")) {
                doUpdate(pwd);                
            }
            
            
            
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }

    DataEncryptor encryptor = new DataEncryptor();
    
    String fileName = "policyStoreConnect.properties";
    
    void doCheck(String pwd) {
        SessionStore_LdapDelete2 delete = new SessionStore_LdapDelete2();
        
        System.out.println("Comparing Password to one in : " + fileName);
        
        RuntimeProperties props = delete.getPolicyStoreConnectProperties();
        
        String encValue = props.getProperty("ldapUserPasswordEnc");
        
        String decPassword = encryptor.decryptString(encValue);
        
        if (decPassword.equals(pwd)) {
            System.out.println("the password matches the one stored in " + fileName);
        }
        else {
            System.out.println("the password does NOT match the one stored in " + fileName);
        }
    }
    
    void doUpdate(String pwd) {
        String encryptedPassword = encryptor.encryptString(pwd);
        System.out.println("ldapUserPasswordEnc=" + encryptedPassword);
        System.out.println("");
        System.out.println("Please update the entry in : " + fileName);
        
    }
}
